import java.awt.Rectangle;

/**
 * Ein Rechteck, das manipuliert werden kann und sich selbst auf einer
 * Leinwand zeichnet.
 * 
 * @author  Michael Klling und David J. Barnes gendert von A. Dietz (7.Mrz 2007)
 */

public class Rechteck
{
  private int breite;
  private int hoehe;
  private int xPosition;
  private int yPosition;
  private String farbe;
  private Rectangle myGraphObject;
  private Leinwand leinwand;
  
  
  
  
  /**
   * Erzeuge ein neues Rechteck mit der linken oberen Ecke (x,y) und der Breite b und der Hhe h.
   *  @param x  die x-Koordinate des linken oberen Eckpunktes
   *  @param y  die y-Koordinate des linken oberen Eckpunktes
   *  @param b  die Breite des Rechteckes
   *  @param h  die Hhe des Rechteckes
   *  @param f  die Farbe des Rechteckes
   */
  public Rechteck(int x, int y, int b, int h, String f)
  {
    xPosition = x;
    yPosition = y;
    breite=b;
    hoehe=h;
    farbe = f;
    myGraphObject = new Rectangle(xPosition, yPosition, breite, hoehe);
    leinwand = Leinwand.gibLeinwand();
  }


  /**
   * ndere die Breite dieses Rechteck in 'neueBreite'.
   * 'neueBreite' muss groesser gleich Null sein.
   * @param neueBreite die neue Breite des Rechteckes
   */
  public void setBreite(int neueBreite)
  {
    breite = neueBreite;
    
  }

  /**
   * ndere die Hhe dieses Rechteck in 'neueHoehe'.
   * 'neueHoehe' muss groesser gleich Null sein.
   * @param neueHoehe die neue Hhe des Rechteckes
   */
  public void setHoehe(int neueHoehe)
  {
    hoehe = neueHoehe;
   
  }
  
  /**
   * ndere die Farbe dieses Rechtecks in 'neueFarbe'.
   * Gltige Angaben sind "rot", "gelb", "blau", "gruen",
   * "lila" und "schwarz".
    * @param neueFarbe die neue Farbe des Rechteckes
   */
  public void farbeAendern(String neueFarbe)
  {
    farbe = neueFarbe;
  }

  
  /**
   * Verschiebe die Position des Rechtecks
   * (Angabe der Verschiebung in x- und y-Richtung).
   * @param dx  Verschiebung in x-Richtung
   * @param dy  Verschiebung in y-Richtung
   */
  public void verschieben(int neuesX, int neuesY)
  {
    xPosition = xPosition + neuesX;
    yPosition = yPosition + neuesY;
  }
  
  /**
   * Setze das Rechteck auf eine neue Position
   * (Angabe der x- und y- Koordinate grer als Null).
   * @param neuesX  x-Position der linken oberen Ecke
   * @param neuesY  y-Position der linken oberen Ecke
   */
  public void setPosition(int neuesX, int neuesY)
  {
    if (neuesX>0 && neuesY>0)
    {
      xPosition = neuesX;
      yPosition = neuesY;
    }
    else
      System.out.println("Ungltige Werte!");
  }
  
  
  /** Rckgabe der x-Position der linken oberen Ecke des Rechtecks
  * @return xPosition x-Position der linken oberen Ecke des Rechtecks
  */ 
  public int getX()
  {
      return xPosition;
  }
  
  /** Rckgabe der y-Position der linken oberen Ecke des Rechtecks
  * @return yPosition y-Position der linken oberen Ecke des Rechtecks
  */ 
  public int getY()
  {
      return yPosition;
  }
  
  /** Rckgabe der Breite des Rechtecks
  * @return breite Breite des Rechtecks
  */ 
  public int getBreite()
  {
      return breite;
  }
  
  /** Rckgabe der Hhe des Rechtecks
  * @return hoehe Hhe des Rechtecks
  */ 
  public int getHoehe()
  {
      return hoehe;
  }
  
  
  
    
    
  
  /**
   * Zeichne dieses Rechteck mit seinen aktuellen Werten auf den Bildschirm.
   */
  
  public void zeichnen()
  {
    
      myGraphObject.setRect(xPosition, yPosition, breite, hoehe);
      leinwand.zeichne(farbe,myGraphObject);
      
    //  leinwand.warte(10);
    
  }

  
  /**
   * Lsche die letzte Zeichnung dieses Rechtecks vom Bildschirm.
   */
  public void loeschen()
  {
     /*  myGraphObject.setRect(1000, 1000, 0, 0);
      leinwand.zeichne(farbe,myGraphObject);
      
      leinwand.warte(10);
      */
    leinwand.entferne(myGraphObject);
    
  }
}
